/*
    Copyright 2005-2008 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef GRAPHICALGUISERVER_H
#define GRAPHICALGUISERVER_H

#include <guiserver_interface.h>

#include <QtCore/QObject>

class QWidget;

class GraphicalGuiServer : public QObject, public NSCore::GuiServer_Interface
{
	Q_OBJECT
	public:
		GraphicalGuiServer( QWidget*, QObject* =0 );
		~GraphicalGuiServer() {}

	public slots:
		void message( const QString&, const QString& ) const;
		bool messageYesNo( const QString&, const QString& ) const;
		bool messageOkCancel( const QString&, const QString& ) const;

		double getDouble( const QString&, const QString&, double, double, double ) const;
		int getInt( const QString&, const QString&, int, int, int ) const;
		QString getString( const QString&, const QString&, const QString& ) const;
		QString getItem( const QString&, const QString&, const QStringList& ) const;

		QString getItem( const QString&, const QString&, const QList<ListItem> ) const;

		QString getFileName( const QString& title, const QString& dir, const QString& filter, const FileType& );

	private:
		QWidget* _parent;
};

#endif // GRAPHICALGUISERVER_H

