/*
    Copyright 2005-2008 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file gpl-3.0.txt. If not, see
    <http://www.gnu.org/licenses/>.

*/
#include <QtCore/QDebug>
#include <cmath>
#include <iostream>

#include "lowpass.h"

int main(  int argc, char** argv )
{
	qDebug() << "Low-Pass Test starting...";

	const int size = 500;

	//int* bla;
	srand( 5 /* *bla */ );

	double* data = new double[ size ];
	for ( int i=0; i<size; ++i ) {
		data[ i ] = rand() * 1.0 / RAND_MAX;
	}
	data[ size/2 ] = 2;

	double* v = new double[ 3 ];
	v[ 0 ] = 0.0;
	v[ 1 ] = 0.0;
	double* out1 = new double[ size ];
	int ns = 5;
	std::vector<LowPass::triple> t = LowPass::lpdes( 0.1, 1, ns );
	std::vector<double*> buffers;
	buffers.push_back( data );
	for ( int i=0; i<ns-1; i++ )
		buffers.push_back( new double[ size ] );
	buffers.push_back( out1 );
	for ( uint j=0; j<t.size(); ++j ) {
		double* in = buffers.at( j );
		double* out = buffers.at( j+1 );
		for ( int i=0; i<size; ++i ) {
			v[ 2 ] = in[ i ];
			out[ i ] = t.at( j ).a * ( v[ 2 ] + 2 * v[ 1 ] + v[ 0 ] ) - t.at( j ).b * out[ i-1 ] - t.at( j ).c * out[ i-2 ];
			v[ 0 ] = v[ 1 ];
			v[ 1 ] = v[ 2 ];
		}
	}

	for ( int i=0; i<size; ++i )
		std::cout << i << "\t" << data[ i ]
			<< "\t" << out1[ i ]
			//<< "\t" << out2[ i ]
			//<< "\t" << out3[ i ]
			<< std::endl;
	std::cout << std::endl << std::endl;

	qDebug() << "...finished.";
	return 0;
}

