/*
    Copyright 2005-2008 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef SCRIPTSNIPPET_PRIVATE_H
#define SCRIPTSNIPPET_PRIVATE_H

#include "scriptsnippet_base.h"

namespace NSScript {

	/**
	 * @private
	 *
	 * @brief Private class simply to keep the ScriptSnippet-Interface clean.
	 */
	class ScriptSnippet_Private : public Ui::ScriptSnippet_Base
	{
		public:
			QStringList _states;
			int _currentstate;

			void checkButtons() {
				btnUndo->setEnabled( false );
				btnRedo->setEnabled( false );
				if ( _states.size() > 1 )
					btnUndo->setEnabled( true );
				if ( _currentstate < _states.size() )
					btnRedo->setEnabled( true );
			}
	};

};

#endif // SCRIPTSNIPPET_PRIVATE_H

